//
//  Array+removeDuplicates.swift
//  kaomojiEmoticonKeyboard
//
//  Created by Robert McGovern on 17/02/2021.
//
// extensoin from Paul Hudson - https://www.hackingwithswift.com/example-code/language/how-to-remove-duplicate-items-from-an-array

import Foundation

/*
 provides two methods: one called removingDuplicates() that returns an array with duplicates removed, and one called removeDuplicates() that changes the array in place.
 */

public extension Array where Element: Hashable {
    func removingDuplicates() -> [Element] {
        var addedDict = [Element: Bool]()

        return filter {
            addedDict.updateValue(true, forKey: $0) == nil
        }
    }

    mutating func removeDuplicates() {
        self = self.removingDuplicates()
    }
}
