//
//  Color+fromString+ToString.swift
//  kaomojiEmoticonKeyboard
//
//  Created by Robert McGovern on 25/11/2020.
//

import SwiftUI

public extension Color {
    func toString() -> String {
        let uiColor = UIColor(self)
        var red: CGFloat = 0
        var green: CGFloat = 0
        var blue: CGFloat = 0
        var alpha: CGFloat = 0
        
        uiColor.getRed(&red, green: &green, blue: &blue, alpha: &alpha)
        
        return "\(red),\(green),\(blue),\(alpha)"
    }
    
    static func fromString(_ string: String) -> Color {
        let rgbArray = string.components(separatedBy: ",")
        if let red = Double(rgbArray[0]), let green = Double(rgbArray[1]), let blue = Double(rgbArray[2]), let alpha = Double(rgbArray[3]) {
            return Color(.sRGB, red: red, green: green, blue: blue, opacity: alpha)
        } else {
            return Color.pink
        }
    }
}
